/* Parameters for execution on Apple A/UX, for GDB, the GNU debugger.
   Copyright (C) 1992 Thomas Eberhardt (thomas@mathematik.uni-Bremen.de)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#define USG

#define NEED_POSIX_SETPGID

#define NO_SYS_FILE

#define HOST_BYTE_ORDER BIG_ENDIAN

#define HAVE_TERMIO

#define HAVE_SIGSETMASK 1

#define SYS_SIGLIST_MISSING 1

extern char *strdup();

#define REGISTER_ADDR(u_ar0, regno)					\
  (unsigned)								\
  ((regno) < PS_REGNUM							\
   ? &((int *)(u_ar0))[(regno) + R0]					\
   : ((regno) == PS_REGNUM						\
      ? &((int *)(u_ar0))[RPS]						\
      : &((int *)(u_ar0))[PC]))

#define FP_REGISTER_ADDR(regno)						\
  ((regno) < FPC_REGNUM							\
   ? offsetof(struct user, u_fpdreg[(regno) - FP0_REGNUM])		\
   : offsetof(struct user, u_fpsysreg[(regno) - FPC_REGNUM]))

/* Interface definitions for kernel debugger KDB.  */

/* Map machine fault codes into signal numbers.
   First subtract 0, divide by 4, then index in a table.
   Faults for which the entry in this table is 0
   are not handled by KDB; the program's own trap handler
   gets to handle then.  */

#define FAULT_CODE_ORIGIN 0
#define FAULT_CODE_UNITS 4
#define FAULT_TABLE    \
{ 0, 0, 0, 0, SIGTRAP, 0, 0, 0, \
  0, SIGTRAP, 0, 0, 0, 0, 0, SIGKILL, \
  0, 0, 0, 0, 0, 0, 0, 0, \
  SIGILL }

/* Start running with a stack stretching from BEG to END.
   BEG and END should be symbols meaningful to the assembler.
   This is used only for kdb.  */

#define INIT_STACK(beg, end)  \
{ asm (".globl end");         \
  asm ("movel #end, %sp");      \
  asm ("movel #0,%a6"); }

/* Push the frame pointer register on the stack.  */
#define PUSH_FRAME_PTR        \
  asm ("movel %a6,%sp@-");

/* Copy the top-of-stack to the frame pointer register.  */
#define POP_FRAME_PTR  \
  asm ("movl %sp@,%a6");

/* After KDB is entered by a fault, push all registers
   that GDB thinks about (all NUM_REGS of them),
   so that they appear in order of ascending GDB register number.
   The fault code will be on the stack beyond the last register.  */

#define PUSH_REGISTERS        \
{ asm ("clrw @%sp-");	      \
  asm ("pea %sp@(10)");	      \
  asm ("movem #0xfffe,%sp@-"); }

/* Assuming the registers (including processor status) have been
   pushed on the stack in order of ascending GDB register number,
   restore them and return to the address in the saved PC register.  */

#define POP_REGISTERS          \
{ asm ("subil #8,%sp@(28)");     \
  asm ("movem %sp@,#0xffff"); \
  asm ("rte"); }
